﻿using System;
using Newtonsoft.Json.Linq;

namespace DigiLockerAuth
{
    public class AutomateDigiLockerSDK
    {
        private static String parsedAccessToken;

        private static String parsedRefreshToken;

        //private static String parsedCode;

        //private static String clientId = DigiLockerSDK.getClientId();

        /*

        PROTOTYPE TO AUTOMATICALLY FETCH URL FROM BROWSER AND PARSE IT TO GET THE AUTH CODE.

        Try Using:
        chrome.tabs.query({ currentWindow: true, active: true }, function(tabs) {
            console.log(tabs[0].url);
            var uriParsed = tabs[0].url;
         }); ??
        public static string AutomateAuthorizationFlow()
        {

            //Process.Start("https://api.digitallocker.gov.in/public/oauth2/1/authorize?response_type=code&client_id="+clientId+"&state=1234&redirect_uri=http://localhost:9286/index.html");

            Uri unparsedUri = new Uri("https://localhost:9286/index.html?code=e78f0a07285c57a2cdf6d126804eae5daee1&state=1234"); //response

            String parsedCode = HttpUtility.ParseQueryString(unparsedUri.Query).Get("code");

            Console.WriteLine("Parsed code for client: " + clientId);

            Console.WriteLine(parsedCode);

            setParsedCode(parsedCode);
            
            return "";
        }*/

        public static string AutomateFetchAccessToken(String codeReceived, String clientId, String clientSecret) //use this to initiate instances which need access_token initialization
        {
            DigiLockerSDK digiSdk = new DigiLockerSDK();

            digiSdk.setCodeReceived(codeReceived);
            digiSdk.setClientId(clientId);
            digiSdk.setClientSecret(clientSecret);

            String responseGetAccessToken = digiSdk.getAccessToken();
            //String responseGetRefreshToken = digiSdk.getRefreshToken();

            JObject rootObject = JObject.Parse(responseGetAccessToken);

            setParsedAccessToken(rootObject.GetValue("access_token").ToString());

            return getParsedAccessToken();
        }

        public static string AutomateFetchRefreshToken()//use this to initiate instances which need refresh_token initialization
        {
            DigiLockerSDK digiSdk = new DigiLockerSDK();

            String responseGetAccessToken = digiSdk.getAccessToken();
            //String responseGetRefreshToken = digiSdk.getRefreshToken();

            JObject rootObject = JObject.Parse(responseGetAccessToken);

            Console.WriteLine("Extracted Refresh Token: " + rootObject.GetValue("refresh_token"));
            setParsedRefreshToken(rootObject.GetValue("refresh_token").ToString());

            return getParsedRefreshToken();

        }


        public static String getParsedAccessToken() //getter for returning the parsed AccessToken
        {
            return parsedAccessToken;
        }
        public static void setParsedAccessToken(String pAT) //setter for Initializing the parsed AccessToken
        {
            parsedAccessToken = pAT;
        }


        public static String getParsedRefreshToken() //getter for returning the parsed RefreshToken
        {
            return parsedRefreshToken;
        }
        public static void setParsedRefreshToken(String pRT) //setter for Initializing the parsed RefreshToken
        {
            parsedRefreshToken = pRT;
        }
        /*
        public static String getParsedCode()
        {
            return parsedCode;
        }
        public static void setParsedCode(String pC)
        {
            parsedCode = pC;
        }*/
    }
}